#DEFINE SCREEN_RATIO 0.6
#DEFINE SCREEN_MIN_X 800
#DEFINE SCREEN_MIN_Y 600

#INCLUDE "AppEvent.CH"
#INCLUDE "Gra.CH"
#INCLUDE "NLS.CH"
#INCLUDE "Xbp.CH"

Static nLayoutAlign

FUNCTION Main()
   Local mp1, mp2
   Local nEvent
   Local oXbp

   LayoutManager()
   SetAppFocus(SetAppwindow())
   MakeATab()

   nEvent := xbe_None
   oXbp := mp1 := mp2 := nEvent
   WHILE nEvent <> xbeP_Close
      nEvent := AppEvent(@mp1, @mp2, @oXbp)
      oXbp:handleEvent(nEvent, mp1, mp2)
   END

RETURN (.T.)

FUNCTION MakeATab()
   Local aPos, aSize, aPP
   Local nI, nLen
   Local oParent, oTab

   oParent := Rootwindow():drawingArea
   aSize := oParent:currentSize()
   aPos := Array(2)
   FOR nI := 1 TO 2
      aSize[nI] -= 20
      aPos[nI] := 10
   NEXT
   aPP := {{XBP_PP_BGCLR, GRA_CLR_GREEN}}
   oTab := XbpTabPage():new(oParent, oParent, aPos, aSize, aPP)
   oTab:caption := "ich bin's"
   oTab:layoutAlign := nLayoutAlign
   oTab:create()
   oTab:maximize()

RETURN (.T.)

FUNCTION DBESys()
   // keine DBE erforderlich
RETURN (.T.)

FUNCTION AppSys()
   Local aSize, aPos[2], aSizeNew[2], aPP
   Local nI
   Local oDlg

   SetLocale(NLS_ICURRENCYEURO, "1")
   SET CHARSET TO ANSI
   SET DATE GERMAN
   SET CENTURY ON

   LayoutManager()
   nLayoutAlign := XBPLAYOUT_RELLEFT + XBPLAYOUT_RELTOP // + XBPLAYOUT_RELWIDTH + XBPLAYOUT_RELHEIGHT

   aSize := AppDesktop():currentSize()
   FOR nI := 1 TO 2
      aSizeNew[nI] := Int(aSize[nI] * SCREEN_RATIO)
   NEXT
   IF aSizeNew[1] < SCREEN_MIN_X
      aSizeNew[1] := SCREEN_MIN_X
   ENDIF
   IF aSizeNew[2] < SCREEN_MIN_Y
      aSizeNew[2] := SCREEN_MIN_Y
   ENDIF
   aPos[1] := Int((aSize[1] - aSizeNew[1]) / 2)
   aPos[2] := Int((aSize[2] - aSizeNew[2]) / 2)
   aPP := {{XBP_PP_BGCLR, GRA_CLR_YELLOW}}
   oDlg := XbpDialog():new(AppDesktop(), AppDesktop(), aPos, aSizeNew, aPP, .F.)
   oDlg:sysmenu := .T.
   oDlg:hideButton := .T.
   oDlg:taskList := .T.
   oDlg:close := {|| WinManKill(), _QUIT()}
   oDlg:title := ""
   oDlg:icon := 2001
   oDlg:layoutAlign := nLayoutAlign
   oDlg:create()
   RootWindow(oDlg)
   oDlg:setTitle(GetProgramTitle())
   oDlg:drawingArea:scrollBars := XBP_SCROLLBAR_VERT
   oDlg:show()

   SetAppWindow(oDlg)

RETURN (.T.)

FUNCTION RootWindow(oDlg)
   Static oStatic
   IF oDlg <> NIL
      oStatic := oDlg
   ENDIF
   IF oStatic = NIL
      ConfirmBox(, "Fehler", "Programm nicht richtig geladen", XBPMB_CRITICAL, XBPMB_OK)
      QUIT
   ENDIF
RETURN (oStatic)

FUNCTION WinManKill()
RETURN (.T.)

FUNCTION GetProgramTitle()
   Local cTitle
   cTitle := "LayoutManager() und XbpTabPage()"
RETURN (cTitle)
